#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	ll t, n, m;
	cin >> t;
	while(t--)
    {
        cin >> n >> m;
        vector<ll> a(n);
        vector<ll> b(m);
        vector<ll> r;
        vector<ll> ci;
        vector<ll> rb;
        bool res;
        ll x=1000000000000000000;
        for(ll i=0; i<n; i++)
        {
            cin >> a[i];
        }
        for(ll i=0; i<m; i++)
        {
            cin >> b[i];
        }
        sort(a.begin(),a.end());
        sort(b.begin(),b.end());
        for(ll i=1; i<n; i++)
        {
            r.push_back(a[i]-a[i-1]);
            x=min(x,r[i-1]);
        }
        for(ll i=0; i<b.size(); i++)
        {
            rb.push_back(abs(b[i]-a[0]));
        }
        for(ll i=1; i*i<=x; i++)
        {
            if(x%i==0)
            {
                ci.push_back(i);
                if(i*i!=x)
                {
                    ci.push_back(x/i);
                }
            }
        }
        for(ll i=1; i<ci.size(); i++)
        {
            res=true;
            for(ll k=0; k<r.size(); k++)
            {
                if(r[k]%ci[i]!=0)
                {
                    res=false;
                    break;
                }
            }
            if(res)
            {
                for(ll k=0; k<rb.size(); k++)
                {
                    if(rb[k]%ci[i]==0)
                    {
                        res=false;
                        break;
                    }
                }
            }
            if(res)
            {
                break;
            }
        }
        if(res)
        {
            cout << 1 << "\n";
        }
        else
        {
            cout << 0 << "\n";
        }
    }
}